// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.22.0
// source: queries.sql

package generated

import (
	"context"
	"time"

	"github.com/google/uuid"
)

const assessmentCreate = `-- name: AssessmentCreate :exec
INSERT INTO digilab_demo_fbs.assessments
(id, tariff_id, decision_id, woz_object_id, 
    owner_type, owner_id, owner_label,
    owner_address_id, owner_address_line_1, owner_address_line_2,
    woz_address_id, woz_address_line_1, woz_address_line_2,
    woz_amount, registered_people, created_at, effective_at) 
VALUES (
    $1, $2, $3, $4, $5, $6, $7, $8, $9, 
    $10, $11, $12, $13, $14, $15, $16, $17
)
`

type AssessmentCreateParams struct {
	ID                uuid.UUID
	TariffID          uuid.UUID
	DecisionID        uuid.UUID
	WozObjectID       uuid.UUID
	OwnerType         string
	OwnerID           uuid.UUID
	OwnerLabel        string
	OwnerAddressID    uuid.UUID
	OwnerAddressLine1 string
	OwnerAddressLine2 string
	WozAddressID      uuid.UUID
	WozAddressLine1   string
	WozAddressLine2   string
	WozAmount         int32
	RegisteredPeople  int32
	CreatedAt         time.Time
	EffectiveAt       time.Time
}

func (q *Queries) AssessmentCreate(ctx context.Context, arg *AssessmentCreateParams) error {
	_, err := q.exec(ctx, q.assessmentCreateStmt, assessmentCreate,
		arg.ID,
		arg.TariffID,
		arg.DecisionID,
		arg.WozObjectID,
		arg.OwnerType,
		arg.OwnerID,
		arg.OwnerLabel,
		arg.OwnerAddressID,
		arg.OwnerAddressLine1,
		arg.OwnerAddressLine2,
		arg.WozAddressID,
		arg.WozAddressLine1,
		arg.WozAddressLine2,
		arg.WozAmount,
		arg.RegisteredPeople,
		arg.CreatedAt,
		arg.EffectiveAt,
	)
	return err
}

const assessmentDelete = `-- name: AssessmentDelete :exec
DELETE FROM digilab_demo_fbs.assessments
WHERE id=$1
`

func (q *Queries) AssessmentDelete(ctx context.Context, id uuid.UUID) error {
	_, err := q.exec(ctx, q.assessmentDeleteStmt, assessmentDelete, id)
	return err
}

const assessmentGet = `-- name: AssessmentGet :one
SELECT id, internal_id, tariff_id, decision_id, woz_object_id, 
    owner_type, owner_id, owner_label,
    owner_address_id, owner_address_line_1, owner_address_line_2,
    woz_address_id, woz_address_line_1, woz_address_line_2,
    woz_amount, registered_people, created_at, effective_at
FROM digilab_demo_fbs.assessments
WHERE id=$1
`

func (q *Queries) AssessmentGet(ctx context.Context, id uuid.UUID) (*DigilabDemoFbsAssessment, error) {
	row := q.queryRow(ctx, q.assessmentGetStmt, assessmentGet, id)
	var i DigilabDemoFbsAssessment
	err := row.Scan(
		&i.ID,
		&i.InternalID,
		&i.TariffID,
		&i.DecisionID,
		&i.WozObjectID,
		&i.OwnerType,
		&i.OwnerID,
		&i.OwnerLabel,
		&i.OwnerAddressID,
		&i.OwnerAddressLine1,
		&i.OwnerAddressLine2,
		&i.WozAddressID,
		&i.WozAddressLine1,
		&i.WozAddressLine2,
		&i.WozAmount,
		&i.RegisteredPeople,
		&i.CreatedAt,
		&i.EffectiveAt,
	)
	return &i, err
}

const assessmentGetOnTaxBill = `-- name: AssessmentGetOnTaxBill :many
SELECT id, internal_id, tariff_id, decision_id, woz_object_id, 
    owner_type, owner_id, owner_label,
    owner_address_id, owner_address_line_1, owner_address_line_2,
    woz_address_id, woz_address_line_1, woz_address_line_2,
    woz_amount, registered_people, created_at, effective_at
FROM digilab_demo_fbs.assessments
LEFT JOIN digilab_demo_fbs.tax_bill_assessment
    ON tax_bill_assessment.assessment_id = assessments.id
WHERE tax_bill_assessment.tax_bill_id=$1
`

func (q *Queries) AssessmentGetOnTaxBill(ctx context.Context, taxBillID uuid.UUID) ([]*DigilabDemoFbsAssessment, error) {
	rows, err := q.query(ctx, q.assessmentGetOnTaxBillStmt, assessmentGetOnTaxBill, taxBillID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*DigilabDemoFbsAssessment{}
	for rows.Next() {
		var i DigilabDemoFbsAssessment
		if err := rows.Scan(
			&i.ID,
			&i.InternalID,
			&i.TariffID,
			&i.DecisionID,
			&i.WozObjectID,
			&i.OwnerType,
			&i.OwnerID,
			&i.OwnerLabel,
			&i.OwnerAddressID,
			&i.OwnerAddressLine1,
			&i.OwnerAddressLine2,
			&i.WozAddressID,
			&i.WozAddressLine1,
			&i.WozAddressLine2,
			&i.WozAmount,
			&i.RegisteredPeople,
			&i.CreatedAt,
			&i.EffectiveAt,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const assessmentGetOwnersBasedOnRun = `-- name: AssessmentGetOwnersBasedOnRun :many
SELECT owner_id, owner_type, owner_label 
FROM digilab_demo_fbs.runs
LEFT JOIN digilab_demo_fbs.tariffs 
    ON tariffs.run_id=runs.id
RIGHT JOIN digilab_demo_fbs.assessments
    ON assessments.tariff_id=tariffs.id
WHERE runs.id=$1
GROUP BY owner_id, owner_type, owner_label
`

type AssessmentGetOwnersBasedOnRunRow struct {
	OwnerID    uuid.UUID
	OwnerType  string
	OwnerLabel string
}

func (q *Queries) AssessmentGetOwnersBasedOnRun(ctx context.Context, id uuid.UUID) ([]*AssessmentGetOwnersBasedOnRunRow, error) {
	rows, err := q.query(ctx, q.assessmentGetOwnersBasedOnRunStmt, assessmentGetOwnersBasedOnRun, id)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*AssessmentGetOwnersBasedOnRunRow{}
	for rows.Next() {
		var i AssessmentGetOwnersBasedOnRunRow
		if err := rows.Scan(&i.OwnerID, &i.OwnerType, &i.OwnerLabel); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const assessmentListAsc = `-- name: AssessmentListAsc :many
SELECT objs.id, objs.internal_id, objs.tariff_id, objs.decision_id, objs.woz_object_id, objs.owner_type, objs.owner_id, objs.owner_label, objs.owner_address_id, objs.owner_address_line_1, objs.owner_address_line_2, objs.woz_address_id, objs.woz_address_line_1, objs.woz_address_line_2, objs.woz_amount, objs.registered_people, objs.created_at, objs.effective_at FROM (
    SELECT id, internal_id, tariff_id, decision_id, woz_object_id, 
        owner_type, owner_id, owner_label,
        owner_address_id, owner_address_line_1, owner_address_line_2,
        woz_address_id, woz_address_line_1, woz_address_line_2,
        woz_amount, registered_people, created_at, effective_at
    FROM digilab_demo_fbs.assessments    
    WHERE assessments.internal_id > (
        SELECT sub_qry.internal_id
        FROM digilab_demo_fbs.assessments as sub_qry
        WHERE sub_qry.id=$1
    )
    ORDER BY assessments.internal_id ASC
    LIMIT $2
) objs ORDER BY objs.internal_id DESC
`

type AssessmentListAscParams struct {
	ID    uuid.UUID
	Limit int32
}

func (q *Queries) AssessmentListAsc(ctx context.Context, arg *AssessmentListAscParams) ([]*DigilabDemoFbsAssessment, error) {
	rows, err := q.query(ctx, q.assessmentListAscStmt, assessmentListAsc, arg.ID, arg.Limit)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*DigilabDemoFbsAssessment{}
	for rows.Next() {
		var i DigilabDemoFbsAssessment
		if err := rows.Scan(
			&i.ID,
			&i.InternalID,
			&i.TariffID,
			&i.DecisionID,
			&i.WozObjectID,
			&i.OwnerType,
			&i.OwnerID,
			&i.OwnerLabel,
			&i.OwnerAddressID,
			&i.OwnerAddressLine1,
			&i.OwnerAddressLine2,
			&i.WozAddressID,
			&i.WozAddressLine1,
			&i.WozAddressLine2,
			&i.WozAmount,
			&i.RegisteredPeople,
			&i.CreatedAt,
			&i.EffectiveAt,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const assessmentListDesc = `-- name: AssessmentListDesc :many
SELECT id, internal_id, tariff_id, decision_id, woz_object_id, 
    owner_type, owner_id, owner_label,
    owner_address_id, owner_address_line_1, owner_address_line_2,
    woz_address_id, woz_address_line_1, woz_address_line_2,
    woz_amount, registered_people, created_at, effective_at
FROM digilab_demo_fbs.assessments    
WHERE assessments.internal_id < COALESCE((
    SELECT internal_id
    FROM digilab_demo_fbs.assessments as sub_qry
    WHERE sub_qry.id=$1
), $2)
ORDER BY assessments.internal_id DESC
LIMIT $3
`

type AssessmentListDescParams struct {
	ID         uuid.UUID
	InternalID int32
	Limit      int32
}

func (q *Queries) AssessmentListDesc(ctx context.Context, arg *AssessmentListDescParams) ([]*DigilabDemoFbsAssessment, error) {
	rows, err := q.query(ctx, q.assessmentListDescStmt, assessmentListDesc, arg.ID, arg.InternalID, arg.Limit)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*DigilabDemoFbsAssessment{}
	for rows.Next() {
		var i DigilabDemoFbsAssessment
		if err := rows.Scan(
			&i.ID,
			&i.InternalID,
			&i.TariffID,
			&i.DecisionID,
			&i.WozObjectID,
			&i.OwnerType,
			&i.OwnerID,
			&i.OwnerLabel,
			&i.OwnerAddressID,
			&i.OwnerAddressLine1,
			&i.OwnerAddressLine2,
			&i.WozAddressID,
			&i.WozAddressLine1,
			&i.WozAddressLine2,
			&i.WozAmount,
			&i.RegisteredPeople,
			&i.CreatedAt,
			&i.EffectiveAt,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const assessmentsListOwner = `-- name: AssessmentsListOwner :many
SELECT assessments.id, assessments.internal_id, tariff_id, decision_id, woz_object_id, 
        owner_type, owner_id, owner_label,
        owner_address_id, owner_address_line_1, owner_address_line_2,
        woz_address_id, woz_address_line_1, woz_address_line_2,
        woz_amount, registered_people, assessments.created_at, effective_at
FROM digilab_demo_fbs.assessments
LEFT JOIN digilab_demo_fbs.runs
    ON runs.id=$2
LEFT JOIN digilab_demo_fbs.tariffs 
    ON tariffs.run_id=runs.id
WHERE owner_id=$1 AND assessments.tariff_id=tariffs.id
`

type AssessmentsListOwnerParams struct {
	OwnerID uuid.UUID
	ID      uuid.UUID
}

func (q *Queries) AssessmentsListOwner(ctx context.Context, arg *AssessmentsListOwnerParams) ([]*DigilabDemoFbsAssessment, error) {
	rows, err := q.query(ctx, q.assessmentsListOwnerStmt, assessmentsListOwner, arg.OwnerID, arg.ID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*DigilabDemoFbsAssessment{}
	for rows.Next() {
		var i DigilabDemoFbsAssessment
		if err := rows.Scan(
			&i.ID,
			&i.InternalID,
			&i.TariffID,
			&i.DecisionID,
			&i.WozObjectID,
			&i.OwnerType,
			&i.OwnerID,
			&i.OwnerLabel,
			&i.OwnerAddressID,
			&i.OwnerAddressLine1,
			&i.OwnerAddressLine2,
			&i.WozAddressID,
			&i.WozAddressLine1,
			&i.WozAddressLine2,
			&i.WozAmount,
			&i.RegisteredPeople,
			&i.CreatedAt,
			&i.EffectiveAt,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const assessmentsListOwnerAll = `-- name: AssessmentsListOwnerAll :many
SELECT assessments.id, assessments.internal_id, tariff_id, decision_id, woz_object_id, 
        assessments.owner_type, assessments.owner_id, assessments.owner_label,
        owner_address_id, owner_address_line_1, owner_address_line_2,
        woz_address_id, woz_address_line_1, woz_address_line_2,
        woz_amount, registered_people, assessments.created_at, effective_at
FROM digilab_demo_fbs.assessments
LEFT JOIN digilab_demo_fbs.tax_bills
    ON tax_bills.owner_id=$1
LEFT JOIN digilab_demo_fbs.tax_bill_assessment
    ON tax_bill_assessment.assessment_id=assessments.id
`

func (q *Queries) AssessmentsListOwnerAll(ctx context.Context, ownerID uuid.UUID) ([]*DigilabDemoFbsAssessment, error) {
	rows, err := q.query(ctx, q.assessmentsListOwnerAllStmt, assessmentsListOwnerAll, ownerID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*DigilabDemoFbsAssessment{}
	for rows.Next() {
		var i DigilabDemoFbsAssessment
		if err := rows.Scan(
			&i.ID,
			&i.InternalID,
			&i.TariffID,
			&i.DecisionID,
			&i.WozObjectID,
			&i.OwnerType,
			&i.OwnerID,
			&i.OwnerLabel,
			&i.OwnerAddressID,
			&i.OwnerAddressLine1,
			&i.OwnerAddressLine2,
			&i.WozAddressID,
			&i.WozAddressLine1,
			&i.WozAddressLine2,
			&i.WozAmount,
			&i.RegisteredPeople,
			&i.CreatedAt,
			&i.EffectiveAt,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const taxBillAssessment = `-- name: TaxBillAssessment :exec
INSERT INTO digilab_demo_fbs.tax_bill_assessment
(tax_bill_id, assessment_id)
VALUES ($1, $2)
`

type TaxBillAssessmentParams struct {
	TaxBillID    uuid.UUID
	AssessmentID uuid.UUID
}

func (q *Queries) TaxBillAssessment(ctx context.Context, arg *TaxBillAssessmentParams) error {
	_, err := q.exec(ctx, q.taxBillAssessmentStmt, taxBillAssessment, arg.TaxBillID, arg.AssessmentID)
	return err
}

const taxBillsCreate = `-- name: TaxBillsCreate :exec
INSERT INTO digilab_demo_fbs.tax_bills 
(id, run_id, owner_type, owner_id, owner_label)
VALUES (
    $1, $2, $3, $4, $5
)
`

type TaxBillsCreateParams struct {
	ID         uuid.UUID
	RunID      uuid.UUID
	OwnerType  string
	OwnerID    uuid.UUID
	OwnerLabel string
}

func (q *Queries) TaxBillsCreate(ctx context.Context, arg *TaxBillsCreateParams) error {
	_, err := q.exec(ctx, q.taxBillsCreateStmt, taxBillsCreate,
		arg.ID,
		arg.RunID,
		arg.OwnerType,
		arg.OwnerID,
		arg.OwnerLabel,
	)
	return err
}
